<Fullscreen
  class="map-wrapper use-highlights {{unless this.embed.isEnabled 'disable'}}"
  data-path="{{@path}}.data.map"
  data-type="map"
  data-name={{@value.name}}
  data-gid={{@value.gid}}
  data-editor="map"
  @isFullscreen={{this.isFullscreen}}
  @onFullScreen={{this.fullScreen}}
  @onFullscreenRequest={{this.fullscreenRequest}}
  {{did-insert this.setup}}
  style={{this.style}}
  ...attributes
>
  <TransitionContainer
    @id={{this.elementId}}
    class="page-col-map-view map-view
      {{if this.isHover 'cursor-pointer'}}
      {{if
        (and this.hasFocus (not this._hasInteractions))
        'map-preparing-focus'
      }}"
    @transitionSteps={{this.transitionSteps}}
    @transition={{this.isPinned}}
    @onTransitionEnd={{this.onTransitionEnd}}
    @onTransitionStart={{this.onTransitionStart}}
    {{did-insert this.setup}}
    {{did-update this.updateState @state}}
  >
    {{#if (eq @value.data.map.mode "use a map")}}
      <View::Base::SourceRecord
        @path={{@path}}
        @model={{@model}}
        @value={{@value}}
        @isEditor={{@isEditor}}
        @onLoad={{this.setupRecord}}
      />
    {{/if}}

    {{#if this.isReady}}
      <Map::Plain
        @onReady={{this.setupMap}}
        @disableInteractions={{true}}
        {{on "touchstart" this.handleMouseOver}}
        {{on "mouseover" this.handleMouseOver}}
        {{on "mouseout" this.handleMouseOut}}
        as |map|
      >
        <div class="{{if @isEditor 'disable-click'}}">
          <Map::View
            @map={{map}}
            @onChange={{this.viewChanged}}
            @extentM={{this.extent}}
            @constraintExtent={{this.constraintExtent}}
          />

          <Map::Layer::Base
            @map={{map}}
            @value={{this.selectedBaseMap}}
            @cacheId={{this.elementId}}
          />

          <Map::Layer::VectorTiles
            @style={{this.mapStyles.styleFunction}}
            @selectedId={{this.selectedFeature}}
            @bearer={{this.bearer}}
            @url={{this.tilesUrl}}
            @map={{map}}
            @onHover={{this.hoverFeature}}
            @onSelect={{this.selectFeature}}
            @cacheId={{this.mapId}}
          />

          {{#if this.showFeaturePopUp}}
            <Map::Overlay
              class="feature-popup"
              @map={{map}}
              @position={{this.featureSelection.coordinates}}
            >
              <Map::Marker::Feature
                @map={{map}}
                @featureId={{this.featureSelection.featureId}}
                @onClose={{this.deselectFeature}}
              />
            </Map::Overlay>
          {{/if}}

          {{#if (eq this.featureSelection.type "pending")}}
            <Map::Overlay
              @map={{map}}
              @position={{this.featureSelection.coordinates}}
            >
              <div class="pending-label content site-list p-2 text-info">
                {{t "feature-pending-message"}}
              </div>
            </Map::Overlay>
          {{/if}}

          {{#if (eq this.featureSelection.type "group")}}
            <Map::Overlay
              @map={{map}}
              @position={{this.featureSelection.coordinates}}
            >
              <Map::Marker::Group
                @map={{map}}
                @feature={{this.featureSelection.group}}
                @onZoom={{this.selectFeature}}
                @onSelect={{this.selectFeature}}
              />
            </Map::Overlay>
          {{/if}}

          {{#if
            (and
              this.position.hasGeoLocationPosition
              @value.data.map.showUserLocation
            )
          }}
            <Map::Layer::UserPosition
              @map={{map}}
              @position={{this.position.center}}
              @accuracy={{this.position.accuracy}}
            />
          {{/if}}

          {{#if this.isPinned}}
            <Map::Container @top={{true}} @right={{true}}>
              <button
                class="btn btn-light btn-unpin m-1"
                type="button"
                {{on "click" this.unpin}}
              >
                <FaIcon @icon="down-left-and-up-right-to-center" />
              </button>
            </Map::Container>

            <Map::Container @top={{true}} @left={{true}}>
              <button
                class="btn btn-light btn-search m-1"
                type="button"
                {{on "click" this.openSearch}}
              >
                <FaIcon @icon="magnifying-glass" class="me-2" />
                {{capitalize (t "search")}}
              </button>
            </Map::Container>
          {{/if}}

          <Map::Container @top={{true}} @right={{true}} class="p-3 d-flex align-items-center">
            {{#if this.hasAutoInteraction}}
              {{#if this.hasInteractions}}
                <div class="unlocked text-muted">
                  <FaIcon @icon="lock-open" />
                </div>
              {{else}}
                <div class="locked text-muted">
                  <FaIcon @icon="lock" />
                </div>
              {{/if}}
            {{/if}}

            {{#if @value.data.map.enableFullMapView}}
              <Link @to={{this.mapViewLink}} @space={{@space}} @isEditor={{@isEditor}} class="ms-3 btn btn-primary btn-browse-map-view">
                {{t "browse map view"}}
              </Link>
            {{/if}}
          </Map::Container>

          <MapAttributions
            @map={{this.map}}
            @baseMap={{this.selectedBaseMap}}
          />

          <Map::Container @right={{true}} @bottom={{true}} class="p-1">
            {{#if @value.data.map.showUserLocation}}
              <Map::ButtonLocalize class={{if this.showZoomButtons "mb-3"}} />
            {{/if}}

            {{#if this.showZoomButtons}}
              <Map::Controls @map={{map}} />
            {{/if}}

            {{#if @value.data.map.showBaseMapSelection}}
              <Map::BaseMapSelect
                @list={{this.baseMaps}}
                @selected={{this.selectedBaseMap}}
                @onSelect={{this.selectBaseMap}}
              />
            {{/if}}
          </Map::Container>

          {{#if (and (not @isEditor) this.hasInteractions)}}
            <Map::Interaction::Defaults @map={{map}} />
          {{/if}}
        </div>
      </Map::Plain>
    {{/if}}

    {{#if @value.data.map.showTitle}}
      <GradientTitle
        @deviceSize={{@deviceSize}}
        @path={{@path}}
        @value={{@value}}
        @record={{this.map}}
        @onChangeState={{@onChangeState}}
        @model={{@model}}
        @space={{@space}}
        @isEditor={{@isEditor}}
        @isHidden={{this.hasInteractions}}
        @onResize={{this.resizeContainer}}
        class="pb-3 title-container"
      />
    {{/if}}
    <div style={{this.loaderStyle}} class="map-focus-loader"></div>
  </TransitionContainer>
</Fullscreen>